
#property copyright "*"
#property link      "*"

#property indicator_chart_window

//---- input parameters
extern int       iHalfPeriod=14;
extern bool      ShowTxt=false;
extern bool      Ray=false;
extern string    s0="==========================";
extern bool      _=false;
extern color     Color_1=Red; 
extern bool      _=false;
extern color     Color_2=Lime; 
extern bool      _=false;
extern color     Color_3=Yellow; 
extern bool      _=false;
extern color     Color_4=DodgerBlue; 
extern bool      _=false;
extern color     Color_5=Violet; 
extern bool      _=false;
extern color     Color_6=Aqua; 
extern bool      =false;
extern color     Color_7=White;


//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

double _v[10];
int    _t[10];
string _tp[10];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(2);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i=ObjectsTotal()-1;i>=0;i--){
      if(StringFind(ObjectName(i),"NDMP_")==0){
         ObjectDelete(ObjectName(i));
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    limit=Bars-IndicatorCounted();
   
      for(int i=limit;i>=0;i--){
         ExtMapBuffer1[i]=0;
         ExtMapBuffer2[i]=0;         
         int hb=Highest(NULL,0,MODE_HIGH,iHalfPeriod*2+1,i+1);
         int lb=Lowest(NULL,0,MODE_LOW,iHalfPeriod*2+1,i+1); 
         
            if(hb==i+iHalfPeriod+2){
               ExtMapBuffer1[hb]=High[hb];
                  for(int j=hb+1;j<Bars;j++){
                     if(ExtMapBuffer1[j]!=0){//Upper

                              if(_t[0]!=Time[hb]){
                                 for(int g=ArraySize(_v)-1;g>0;g--){
                                    _v[g]=_v[g-1];
                                    _t[g]=_t[g-1];                                    
                                    _tp[g]=_tp[g-1]; 
                                 }
                                 _v[0]=High[hb];
                                 _t[0]=Time[hb];
                                 _tp[0]="u";    
                              }                                                                     
                        break;
                     }
                  }
            }
            if(lb==i+iHalfPeriod+2){
               ExtMapBuffer2[lb]=Low[lb];
                  for(j=lb+1;j<Bars;j++){
                     if(ExtMapBuffer2[j]!=0){//Lower
   
                              if(_t[0]!=Time[lb]){
                                 for(g=ArraySize(_v)-1;g>0;g--){
                                    _v[g]=_v[g-1];
                                    _t[g]=_t[g-1]; 
                                    _tp[g]=_tp[g-1];                                                                        
                                 }
                                 _v[0]=Low[lb];
                                 _t[0]=Time[lb];
                                 _tp[0]="l";                                 
                              }                                                                   
                        break;
                     }
                  }               
            } 
/////////////////////////////////////////////////////////////////////////////////

      string tx="";
      bool tv,td;
      string on;
      
      if(_){
         if(_tp[2]=="u" && _tp[1]=="u" && _tp[0]=="u"){
            tx=tx+"  ";
               if(_v[2]<_v[1] && _v[1]<_v[0])tx=tx+"(/) ";
               if(_v[2]>_v[1] && _v[1]>_v[0])tx=tx+"(\\) ";
               if(_v[2]<_v[1] && _v[1]>_v[0])tx=tx+"(/\\) ";                              
               if(_v[2]>_v[1] && _v[1]<_v[0])tx=tx+"(\\/) ";                    
            tv=true;
            CL("NDMP_TVUL_1_"+_t[0],_t[2],_v[2],_t[0],_v[0],false,Color_1);
            CL("NDMP_TVUL_2_"+_t[0],_t[2],_v[2],_t[1],_v[1],false,Color_1);
            CL("NDMP_TVUL_3_"+_t[0],_t[1],_v[1],_t[0],_v[0],false,Color_1);               
         }
         if(_tp[2]=="l" && _tp[1]=="l" && _tp[0]=="l"){
            tx=tx+"  ";
               if(_v[2]<_v[1] && _v[1]<_v[0])tx=tx+"(/) ";
               if(_v[2]>_v[1] && _v[1]>_v[0])tx=tx+"(\\) ";
               if(_v[2]<_v[1] && _v[1]>_v[0])tx=tx+"(/\\) ";                              
               if(_v[2]>_v[1] && _v[1]<_v[0])tx=tx+"(\\/) ";
            td=true;                   
            CL("NDMP_TVLL_1_"+_t[0],_t[2],_v[2],_t[0],_v[0],false,Color_1);
            CL("NDMP_TVLL_2_"+_t[0],_t[2],_v[2],_t[1],_v[1],false,Color_1);
            CL("NDMP_TVLL_3_"+_t[0],_t[1],_v[1],_t[0],_v[0],false,Color_1);                 
         }         
     }    
      if(_){
         if(_tp[1]=="u" && _tp[0]=="u" && !tv){
            tx=tx+"  ";
               if(_v[1]<_v[0])tx=tx+"(/) ";
               if(_v[1]>_v[0])tx=tx+"(\\) ";
               CL("NDMP_DVUL_1_"+_t[0],_t[1],_v[1],_t[0],_v[0],false,Color_2);
         }
         if(_tp[1]=="l" && _tp[0]=="l" && !td){
            tx=tx+"  ";
               if(_v[1]<_v[0])tx=tx+"(/) ";
               if(_v[1]>_v[0])tx=tx+"(\\) ";
               CL("NDMP_DVLL_1_"+_t[0],_t[1],_v[1],_t[0],_v[0],false,Color_2);
         }         
     }        
     if(_){     
         if(_tp[3]=="l" && _tp[2]=="u" && _tp[1]=="l" && _tp[0]=="u"){
            if(MathAbs(_v[3]-_v[2])>MathAbs(_v[2]-_v[1]) && MathAbs(_v[2]-_v[1])>MathAbs(_v[1]-_v[0])){
               tx=tx+"  ";
               CL("NDMP_STUL_1_"+_t[0],_t[2],_v[2],_t[0],_v[0],Ray,Color_3);
               CL("NDMP_STUL_2_"+_t[0],_t[3],_v[3],_t[1],_v[1],Ray,Color_3);               
            }
         }
         if(_tp[3]=="u" && _tp[2]=="l" && _tp[1]=="u" && _tp[0]=="l"){
            if(MathAbs(_v[3]-_v[2])>MathAbs(_v[2]-_v[1]) && MathAbs(_v[2]-_v[1])>MathAbs(_v[1]-_v[0])){
               tx=tx+"  ";   
               CL("NDMP_STLL_1_"+_t[0],_t[2],_v[2],_t[0],_v[0],Ray,Color_3);
               CL("NDMP_STLL_2_"+_t[0],_t[3],_v[3],_t[1],_v[1],Ray,Color_3);                           
            }         
         } 
      }    
     if(_){     
         if(_tp[3]=="l" && _tp[2]=="u" && _tp[1]=="l" && _tp[0]=="u"){
            if(MathAbs(_v[3]-_v[2])<MathAbs(_v[2]-_v[1]) && MathAbs(_v[2]-_v[1])<MathAbs(_v[1]-_v[0])){
               tx=tx+"  ";
               CL("NDMP_RTUL_1_"+_t[0],_t[2],_v[2],_t[0],_v[0],Ray,Color_4);
               CL("NDMP_RTUL_2_"+_t[0],_t[3],_v[3],_t[1],_v[1],Ray,Color_4);                 
            }
         }
         if(_tp[3]=="u" && _tp[2]=="l" && _tp[1]=="u" && _tp[0]=="l"){
            if(MathAbs(_v[3]-_v[2])<MathAbs(_v[2]-_v[1]) && MathAbs(_v[2]-_v[1])<MathAbs(_v[1]-_v[0])){
               tx=tx+"  "; 
               CL("NDMP_RTLL_1_"+_t[0],_t[2],_v[2],_t[0],_v[0],Ray,Color_4);
               CL("NDMP_RTLL_2_"+_t[0],_t[3],_v[3],_t[1],_v[1],Ray,Color_4);                            
            }         
         } 
      }     
      
     if(_){     
         if(_tp[3]=="l" && _tp[2]=="u" && _tp[1]=="l" && _tp[0]=="u"){
            if(_v[2]<_v[0] && _v[3]<_v[1]){
               tx=tx+"  ";
               CL("NDMP_ZZUL_1_"+_t[0],_t[2],_v[2],_t[0],_v[0],Ray,Color_5);
               CL("NDMP_ZZUL_2_"+_t[0],_t[3],_v[3],_t[1],_v[1],Ray,Color_5);                  
            }
         }
         if(_tp[3]=="u" && _tp[2]=="l" && _tp[1]=="u" && _tp[0]=="l"){
            if(_v[2]>_v[0] && _v[3]>_v[1]){
               tx=tx+"  ";  
               CL("NDMP_ZZLL_1_"+_t[0],_t[2],_v[2],_t[0],_v[0],Ray,Color_5);
               CL("NDMP_ZZLL_2_"+_t[0],_t[3],_v[3],_t[1],_v[1],Ray,Color_5);                          
            }         
         } 
      }           
     
     if(_){     
         if(_tp[4]=="u" && _tp[3]=="l" && _tp[2]=="u" && _tp[1]=="l" && _tp[0]=="u"){
            if(_v[4]<_v[2] && _v[2]>_v[0]){
               tx=tx+"- ";
               CL("NDMP_GPUL_1_"+_t[0],_t[4],_v[4],_t[2],_v[2],false,Color_6);
               CL("NDMP_GPUL_2_"+_t[0],_t[2],_v[2],_t[0],_v[0],false,Color_6);
               CL("NDMP_GPUL_3_"+_t[0],_t[3],_v[3],_t[1],_v[1],false,Color_6);                              
            }
         }
         if(_tp[4]=="l" && _tp[3]=="u" && _tp[2]=="l" && _tp[1]=="u" && _tp[0]=="l"){
            if(_v[4]>_v[2] && _v[2]<_v[0]){
               tx=tx+"- ";            
               CL("NDMP_GPLL_1_"+_t[0],_t[4],_v[4],_t[2],_v[2],false,Color_6);
               CL("NDMP_GPLL_2_"+_t[0],_t[2],_v[2],_t[0],_v[0],false,Color_6);
               CL("NDMP_GPLL_3_"+_t[0],_t[3],_v[3],_t[1],_v[1],false,Color_6);   
            }         
         } 
      }      
     if(){     
         if(_tp[6]=="l" && _tp[5]=="u" && _tp[4]=="l" && _tp[3]=="u" && _tp[2]=="l" && _tp[1]=="u" && _tp[0]=="l"){
            if(_v[5]<_v[3] && _v[3]>_v[1] && _v[6]>_v[4] && _v[2]<_v[0]){
               tx=tx+" ";
               CL("NDMP_ALUL_1_"+_t[0],_t[5],_v[5],_t[3],_v[3],false,Color_7);
               CL("NDMP_ALUL_2_"+_t[0],_t[3],_v[3],_t[1],_v[1],false,Color_7);               
               CL("NDMP_ALUL_3_"+_t[0],_t[6],_v[6],_t[4],_v[4],false,Color_7);
               CL("NDMP_ALUL_4_"+_t[0],_t[2],_v[2],_t[0],_v[0],false,Color_7);                
            }
         }
         if(_tp[6]=="u" && _tp[5]=="l" && _tp[4]=="u" && _tp[3]=="l" && _tp[2]=="u" && _tp[1]=="l" && _tp[0]=="u"){
            if(_v[5]>_v[3] && _v[3]<_v[1] && _v[6]<_v[4] && _v[2]>_v[0]){
               tx=tx+" "; 
               CL("NDMP_ALUL_1_"+_t[0],_t[5],_v[5],_t[3],_v[3],false,Color_7);
               CL("NDMP_ALUL_2_"+_t[0],_t[3],_v[3],_t[1],_v[1],false,Color_7);               
               CL("NDMP_ALUL_3_"+_t[0],_t[6],_v[6],_t[4],_v[4],false,Color_7);
               CL("NDMP_ALUL_4_"+_t[0],_t[2],_v[2],_t[0],_v[0],false,Color_7);                            
            }         
         } 
      }       
     
     on="NDMP_"+_t[0];    
     if(tx!="" && ShowTxt){
      if(ObjectFind(on)!=0){
         if(_tp[0]=="u")double pr=_v[0]+Point*15;else pr=_v[0]-Point*15;
         ObjectCreate(on,OBJ_TEXT,0,_t[0],pr);
         ObjectSetText(on,tx,8,"Arial",Yellow);
      }
     }

/////////////////////////////////////////////////////////////////////////////////            
      }

   return(0);
  }
//+------------------------------------------------------------------+

void CL(string ln,datetime tm1,double vl1,datetime tm2,double vl2,bool rp,color cl){
               if(ObjectFind(ln)!=0){
                  ObjectCreate(ln,OBJ_TREND,0,tm1,vl1,tm2,vl2);
                  ObjectSet(ln,OBJPROP_RAY,false);
                  ObjectSet(ln,OBJPROP_COLOR,Yellow);
                  ObjectSet(ln,OBJPROP_RAY,rp);
                  ObjectSet(ln,OBJPROP_COLOR,cl);                  
               } 
}